proc patAnmelden {user port} {
  global userPorts
  set user [string tolower $user]
  set userPorts($user) $port
}
proc patAbmelden {user port} {
  global userPorts
  set user [string tolower $user]
  catch {unset userPorts($user)}
}
proc patPortVon {user} {
  global userPorts
  set user [string tolower $user]
  if {[info exists userPorts($user)]} {
    return $userPorts($user)
  } else {
    return 0
  }
}
proc patDebug {} {
  global userPorts
  set logFile [open "/tmp/patd_[pid].log" w]
  foreach user [array names userPorts] {
    puts $logFile "debug: $user at $userPorts($user)"
  }
  close $logFile
}
proc checkIt {cmd args} {
  return [string match pat* $cmd]
}
catch {wm withdraw .}
if {$tcl_version < 7.5} {
  puts "Patd: Not interpreted by a tclsh with version 7.5 or newer; exited."
  exit 0
}
if {[catch {source $patiencePath/patrpc.tcl} msg]} {
  puts "Patd: Could not read rpc module: $msg; exited."
  exit 0
}
set daemonPort 4567
if {[llength $argv] == 1  && [regexp {^[0-9]*$} $argv]} {
  set daemonPort $argv
}
if {[catch {dp_MakeRPCServer $daemonPort dp_CheckHost checkIt} msg]} {
  puts "Patd: $msg."
  exit 0
} else {
  puts "Patd: successfully started."
}
